//////////////////////////////////////////////////////////////////////
// Created by SmartDesign Wed Feb 20 13:53:49 2019
// Version: v12.0 12.500.0.22
//////////////////////////////////////////////////////////////////////

`timescale 1ns / 100ps

// MIPI_CSI2_RX_PF_IP0
module MIPI_CSI2_RX_PF_IP0(
    // Inputs
    CAM_CLOCK_I,
    L0_HS_DATA_I,
    L0_LP_DATA_I,
    L0_LP_DATA_N_I,
    L1_HS_DATA_I,
    L1_LP_DATA_I,
    L1_LP_DATA_N_I,
    L2_HS_DATA_I,
    L2_LP_DATA_I,
    L2_LP_DATA_N_I,
    L3_HS_DATA_I,
    L3_LP_DATA_I,
    L3_LP_DATA_N_I,
    PARALLEL_CLOCK_I,
    RESET_n_I,
    // Outputs
    data_out_o,
    frame_end_o,
    frame_start_o,
    line_end_o,
    line_start_o,
    line_valid_o,
    word_count_o
);

//--------------------------------------------------------------------
// Input
//--------------------------------------------------------------------
input         CAM_CLOCK_I;
input  [7:0]  L0_HS_DATA_I;
input         L0_LP_DATA_I;
input         L0_LP_DATA_N_I;
input  [7:0]  L1_HS_DATA_I;
input         L1_LP_DATA_I;
input         L1_LP_DATA_N_I;
input  [7:0]  L2_HS_DATA_I;
input         L2_LP_DATA_I;
input         L2_LP_DATA_N_I;
input  [7:0]  L3_HS_DATA_I;
input         L3_LP_DATA_I;
input         L3_LP_DATA_N_I;
input         PARALLEL_CLOCK_I;
input         RESET_n_I;
//--------------------------------------------------------------------
// Output
//--------------------------------------------------------------------
output [7:0]  data_out_o;
output        frame_end_o;
output        frame_start_o;
output        line_end_o;
output        line_start_o;
output        line_valid_o;
output [15:0] word_count_o;
//--------------------------------------------------------------------
// Nets
//--------------------------------------------------------------------
wire          CAM_CLOCK_I;
wire   [7:0]  data_out_o_net_0;
wire          frame_end_o_net_0;
wire          frame_start_o_net_0;
wire   [7:0]  L0_HS_DATA_I;
wire          L0_LP_DATA_I;
wire          L0_LP_DATA_N_I;
wire   [7:0]  L1_HS_DATA_I;
wire          L1_LP_DATA_I;
wire          L1_LP_DATA_N_I;
wire   [7:0]  L2_HS_DATA_I;
wire          L2_LP_DATA_I;
wire          L2_LP_DATA_N_I;
wire   [7:0]  L3_HS_DATA_I;
wire          L3_LP_DATA_I;
wire          L3_LP_DATA_N_I;
wire          line_end_o_net_0;
wire          line_start_o_net_0;
wire          line_valid_o_net_0;
wire          PARALLEL_CLOCK_I;
wire          RESET_n_I;
wire   [15:0] word_count_o_net_0;
wire          frame_end_o_net_1;
wire          frame_start_o_net_1;
wire          line_end_o_net_1;
wire          line_start_o_net_1;
wire          line_valid_o_net_1;
wire   [7:0]  data_out_o_net_1;
wire   [15:0] word_count_o_net_1;
//--------------------------------------------------------------------
// Top level output port assignments
//--------------------------------------------------------------------
assign frame_end_o_net_1   = frame_end_o_net_0;
assign frame_end_o         = frame_end_o_net_1;
assign frame_start_o_net_1 = frame_start_o_net_0;
assign frame_start_o       = frame_start_o_net_1;
assign line_end_o_net_1    = line_end_o_net_0;
assign line_end_o          = line_end_o_net_1;
assign line_start_o_net_1  = line_start_o_net_0;
assign line_start_o        = line_start_o_net_1;
assign line_valid_o_net_1  = line_valid_o_net_0;
assign line_valid_o        = line_valid_o_net_1;
assign data_out_o_net_1    = data_out_o_net_0;
assign data_out_o[7:0]     = data_out_o_net_1;
assign word_count_o_net_1  = word_count_o_net_0;
assign word_count_o[15:0]  = word_count_o_net_1;
//--------------------------------------------------------------------
// Component instances
//--------------------------------------------------------------------
//--------mipicsi2rxdecoderPF   -   Microsemi:SolutionCore:mipicsi2rxdecoderPF:2.1.0
mipicsi2rxdecoderPF #( 
        .g_BUFF_DEPTH        ( 1280 ),
        .g_DATAWIDTH         ( 8 ),
        .g_INPUT_DATA_INVERT ( 0 ),
        .g_LANE_WIDTH        ( 4 ) )
MIPI_CSI2_RX_PF_IP0_0(
        // Inputs
        .CAM_CLOCK_I      ( CAM_CLOCK_I ),
        .PARALLEL_CLOCK_I ( PARALLEL_CLOCK_I ),
        .RESET_n_I        ( RESET_n_I ),
        .L0_HS_DATA_I     ( L0_HS_DATA_I ),
        .L1_HS_DATA_I     ( L1_HS_DATA_I ),
        .L2_HS_DATA_I     ( L2_HS_DATA_I ),
        .L3_HS_DATA_I     ( L3_HS_DATA_I ),
        .L0_LP_DATA_I     ( L0_LP_DATA_I ),
        .L0_LP_DATA_N_I   ( L0_LP_DATA_N_I ),
        .L1_LP_DATA_I     ( L1_LP_DATA_I ),
        .L1_LP_DATA_N_I   ( L1_LP_DATA_N_I ),
        .L2_LP_DATA_I     ( L2_LP_DATA_I ),
        .L2_LP_DATA_N_I   ( L2_LP_DATA_N_I ),
        .L3_LP_DATA_I     ( L3_LP_DATA_I ),
        .L3_LP_DATA_N_I   ( L3_LP_DATA_N_I ),
        // Outputs
        .data_out_o       ( data_out_o_net_0 ),
        .frame_end_o      ( frame_end_o_net_0 ),
        .frame_start_o    ( frame_start_o_net_0 ),
        .line_end_o       ( line_end_o_net_0 ),
        .line_start_o     ( line_start_o_net_0 ),
        .line_valid_o     ( line_valid_o_net_0 ),
        .word_count_o     ( word_count_o_net_0 ) 
        );


endmodule
